package owl.main.fits;

import java.io.File;
import java.io.FileInputStream;
import java.util.ArrayList;

import org.apache.commons.digester3.Digester;

import owl.main.MainApp;


public class FitsHeaderDigester
{
	// +---------------------------------------------------------------------------+
	// | run
	// +---------------------------------------------------------------------------+
	// | Parses a FITS header xml file.
    // +---------------------------------------------------------------------------+
	public ArrayList<FitsHeaderElement> run( File xmlFile )
	{
		ArrayList<FitsHeaderElement> list = null;

		try
		{
			Digester digester = new Digester();
	
			digester.setValidating( false );

			digester.addObjectCreate( "header", "java.util.ArrayList" );
			digester.addObjectCreate( "header/card", "owl.main.fits.FitsHeaderElement" );

			digester.addSetNext( "header/card", "add", "owl.main.fits.FitsHeaderElement" );

			digester.addCallMethod( "header/card/key", "setKey",         0 );
			digester.addCallMethod( "header/card/value", "setValue",     0 );
			digester.addCallMethod( "header/card/comment", "setComment", 0 );

			list = digester.parse( new FileInputStream( xmlFile ) );

//			//  This set of rules calls the addData method and passes in
//			//  three parameters to the method.
//			// +----------------------------------------------------------+
//			digester.addCallMethod( "header/card", "addData", 3 );
//			digester.addCallParam(  "header/card/key",        0 );
//			digester.addCallParam(  "header/card/value",      1 );
//			digester.addCallParam(  "header/card/comment",    2 );
//
//			//  This method starts the parsing of the document.
//			// +----------------------------------------------------------+
//			digester.parse( new FileInputStream( xmlFile ) );
		}
		catch ( Exception e )
		{
			MainApp.error( e.getMessage() );
		}

		return list;
	}

//	// +--------------------------------------------------------------+
//	// |  addData                                                     |
//	// +--------------------------------------------------------------+
//	// |  Called by Digester to add FITS header data, in the form of  |
//	// |  an owl.main.fits.FitsHeaderElement, to the list.            |
//	// +--------------------------------------------------------------+
//	public void addData( String key, String value, String comment )
//	{
//		try
//		{
//			m_list.add( new FitsHeaderElement( key, value, comment ) );
//		}
//		catch ( Exception e )
//		{
//			MainApp.error( e.getMessage() );
//		}
//	}
}
